#include "spawn.h"

#include "..\algorithms.h"

#include "..\dllcore.cpp"
#include "..\datatypes.cpp"
#include "..\algorithms.cpp"
#include "..\player.cpp"
#include "..\commtypes.cpp"
#include "..\map.cpp"

#define UNASSIGNED 0xffff


//////// Bot list ////////

_linkedlist <botInfo> botlist;

botInfo *findBot(CALL_HANDLE handle)
{
	_listnode <botInfo> *parse = botlist.head;

	while (parse)
	{
		botInfo *item = parse->item;

		if (item->validate(handle))
			return item;

		parse = parse->next;
	}

	return 0;
}
void botInfo::UnPrizeRabbit()
{
	if(theRabbit!=NULL) //set the old rabbit back to thier original ship/freq/bty
	{
		String Message;
		if(theRabbit->ship!=RabbitShip)
		{
			Message="*setship ";
			Message+=RabbitShip;
			sendPrivate(theRabbit,Message);
		}

		if(theRabbit->team!=RabbitTeam)
		{
			Message="*setfreq ";
			Message+=RabbitTeam;
			sendPrivate(theRabbit,Message);
		}

		sendPrivate(theRabbit,"*shipreset");
	}	
}
Uint16 botInfo::random_range(Uint16 lowest_number, Uint16 highest_number)
{
    if(lowest_number > highest_number){
        swap(lowest_number, highest_number);
    }
    Uint16 range = highest_number - lowest_number + 1;
    return lowest_number + Uint16(range * rand()/(RAND_MAX + 1.0));
}

Uint32 botInfo::strFirstInstanceOf(char *msg, char *msg2)
{
	Uint32 len1 = STRLEN(msg), len2 = STRLEN(msg2);

	if (len1 < len2)
		return -1;

	for (Uint32 i = 0; i <= (len1 - len2); i++)
	{
		if (msg[i] == msg2[0])
		{
			for (Uint32 i2 = 0; i2 <= len2; i2++)
			{
				if (msg2[i2] == 0)
					return i;

				if (msg[i + i2] != msg2[i2])
					break;
			}
		}
	}

	return -1;
}

String botInfo::strReplace(char *msg, char *from, char *to)
{
	String ret;

	Uint32 fromlen = STRLEN(from);

	Uint32 pos;
	
	while (true)
	{
		pos = strFirstInstanceOf(msg, from);
		if (pos == -1)
		{
			/// Append the tail and go ///

			ret += msg;
			break;
		}

		ret.append(msg, pos);
		ret += to;
		msg += pos + fromlen;
	}

	return ret;
}

void botInfo::PrizeRabbit()
{
	if(!GotBty)
	{
		String Message;
		if(theRabbit->team!=SetFreq && SetFreq!=UNASSIGNED)//setfreq it
		{
			Message="*setfreq ";
			Message+=SetFreq;
			sendPrivate(theRabbit,Message);
		}

		if(theRabbit->ship!=SetShip && SetShip!=UNASSIGNED) //setship it
		{
			Message="*setship ";
			Message+=SetShip+1;
			sendPrivate(theRabbit,Message);
		}
		
		if(!Prizes.IsEmpty())
		{
			String PrizeStr=Prizes;
			String PrizeNum;
			Sint16 Num;

			while(PrizeNum != PrizeStr)
			{
				PrizeNum=PrizeStr.split(',');
				Num=atoi(PrizeNum.msg);
		
				if(Num != 0 && Num >= -28 && Num <= 28)
				{
					Message="*prize #";
					Message+=Num;
					sendPrivate(theRabbit,Message);
				}
			}
		}

		Message="*prize ";
		Message+=Bounty;
		sendPrivate(theRabbit,Message);
		GotBty=true;
	}
}

Player* botInfo::RandPlayer() //This is sloppy :(
{
	Uint16 temp;
	if(theRabbit!=NULL)
	{temp= random_range(0, getIngame()-2);} //if there is a rabbit, dont count as player
	else
	{temp= random_range(0, getIngame()-1);} //if no rabbit, then pick a number 0- (#ofplayers-1)

	Player *p=NULL;
    for(_listnode <Player> *pl=playerlist->head;pl;pl=pl->next)
    {
        if (pl->item->ship!=8 && !pl->item->safety && pl->item!=theRabbit)
		{
			if(!(IgnoreFlaggers && pl->item->flagCount>0))
			{
				if (temp==0)
				{
					p=pl->item;
					break;
			    }
				temp--;
			}
		}
    }
	return p;
}

Uint16 botInfo::getIngame()
{
	Uint16 num=0;
	for(_listnode <Player> *pl=playerlist->head;pl;pl=pl->next)
	{
		if(pl->item->ship!=8 && !pl->item->safety)
		{
			if(!(IgnoreFlaggers && pl->item->flagCount>0))
			{num++;}
		}
	}
	return num;
}

void botInfo::SetRabbit(Player *p)
{
	UnPrizeRabbit();
	
	RabbitTeam=p->team; //store freq/ship of the rabbit
	RabbitShip=p->ship;

	theRabbit=p;//set new rabbit
	PrizeRabbit();

	countdown[0]=RabbitTime;//initiate rabbit timer
	String Message="*timer ";
	Message+=RabbitTime/60;
	sendPublic(Message);//send the timer

	if(ml!=NULL) //may be problem, && ml->next!=NULL
	{
		Message = strReplace(ml->item->theMsg, "%name%", p->name);
		Message = strReplace(Message.msg, "%points%", getString(p->score.killPoints + p->score.flagPoints, 10, 0, false).msg);
		Message = strReplace(Message.msg, "%squad%", p->squad);
		Message = strReplace(Message.msg, "%freq1%", (p->team >= 100 ? "(Private freq)" : getString(p->team, 10, 0, false).msg));
		Message = strReplace(Message.msg, "%freq2%", getString(p->team, 10, 0, false).msg);
		Message = strReplace(Message.msg, "%coord%", getCoords(p->pos.x,p->pos.y).msg);

		if(ml->item->Sound!=UNASSIGNED)//add sound
		{sendPublic(BYTE(ml->item->Sound),Message);}
		else
		{sendPublic(Message);}
		ml=ml->next;//display rabbit message
	}
	Message=p->name;
	Message+=" you have been selected to be the new rabbit! Stay alive for ";
	Message+=RabbitTime/60;
	Message+=" minutes and you win. You may not enter the safety zone or spectate while rabbit.";
	sendPrivate(p,Message);
}


//////// DLL "import" ////////

void botInfo::tell(BotEvent &event)
{
	if (callback && handle)
	{
		event.handle = handle;
		callback(event);
	}
}

void botInfo::gotEvent(BotEvent &event)
{
	if (CONNECTION_DENIED) return;

	switch (event.code)
	{
//////// Periodic ////////
	case EVENT_Tick:
		{
			if(Status && !Enabled && getIngame()>=2)
			{
				sendPublic("*arena Rabbit Enabled! Selecting a Rabbit...");
				Player* randRabbit=RandPlayer();
				if(randRabbit!=NULL)
				{
					Enabled=true;
					SetRabbit(randRabbit);
				}
			}

			if(Enabled && theRabbit!=NULL)
			{
				--countdown[0];

				if(countdown[0]<0)
				{
					TickMsg="*arena Rabbit:";
					TickMsg+=theRabbit->name;
					TickMsg+=" has won! Selecting new rabbit...";
					sendPublic(SND_Hallellula,TickMsg);

					Player* newRabbit=RandPlayer();
					if(newRabbit!=NULL)
					{SetRabbit(newRabbit);}
				}

				if(theRabbit->safety)
				{
					--countdown[1];
					if(countdown[1]<0)
					{
						Player* p=RandPlayer();
						if(p!=NULL)
						{
							TickMsg="*arena Rabbit:";
							TickMsg+=theRabbit->name;
							TickMsg+=" has overstayed his welcome in the safety zone! New Rabbit being picked....";
							sendPublic(TickMsg);
							SetRabbit(p);
						}
					}
				}
				else
				{countdown[1]=SafeTime;}

				if(countdown[0]%60==0) //every min check time-mesages
				{
					Uint16 theTime=countdown[0]/60;
					for(_listnode <TimeMsg> *tl=TimeList.head;tl;tl=tl->next)
					{
						if(tl->item->Time==theTime)
						{
							TickMsg = strReplace(tl->item->theMsg, "%name%", theRabbit->name);
							TickMsg = strReplace(TickMsg.msg, "%points%", getString(theRabbit->score.killPoints + theRabbit->score.flagPoints, 10, 0, false).msg);
							TickMsg = strReplace(TickMsg.msg, "%squad%", theRabbit->squad);
							TickMsg = strReplace(TickMsg.msg, "%freq1%", (theRabbit->team >= 100 ? "(Private freq)" : getString(theRabbit->team, 10, 0, false).msg));
							TickMsg = strReplace(TickMsg.msg, "%freq2%", getString(theRabbit->team, 10, 0, false).msg);
							TickMsg = strReplace(TickMsg.msg, "%coord%", getCoords(theRabbit->pos.x,theRabbit->pos.y).msg);

							if(tl->item->Sound!=UNASSIGNED)
							{sendPublic(BYTE(ml->item->Sound),TickMsg);}
							else	
							{sendPublic(TickMsg);}

							break;
						}
					}
				}
			}
		}
		break;
//////// Arena ////////
	case EVENT_ArenaEnter:
		{
			arena = (char*)event.p[0];
			me = (Player*)event.p[1];	// if(me) {/*we are in the arena*/}
			bool biller_online = *(bool*)&event.p[2];
		}
		break;
	case EVENT_ArenaSettings:
		{
			settings = (arenaSettings*)event.p[0];
		}
		break;
	case EVENT_ArenaLeave:
		{
			sendPublic("*timer 0");
			me = 0;
			Enabled=false;
			theRabbit=NULL;
			killTags();
		}
		break;
	case EVENT_ArenaListEntry:
		{
			char *name = (char*)event.p[0];
			bool current = *(bool*)&event.p[1];
			int population = *(int*)&event.p[2];
		}
		break;
	case EVENT_ArenaListEnd:
		{
			char *name = (char*)event.p[0];
			bool current = *(bool*)&event.p[1];
			int population = *(int*)&event.p[2];
		}
		break;
//////// Flag ////////
	case EVENT_FlagGrab:
		{
			Player *p = (Player*)event.p[0];
			Flag *f = (Flag*)event.p[1];
		}
		break;
	case EVENT_FlagDrop:
		{
			Player *p = (Player*)event.p[0];
		}
		break;
	case EVENT_FlagMove:
		{
			Flag *f = (Flag*)event.p[0];
		}
		break;
	case EVENT_FlagVictory:
		{
			int team = *(int*)&event.p[0];
			int reward = *(int*)&event.p[1];
			if(Enabled && theRabbit!=NULL && theRabbit->team==team)
			{PrizeRabbit();}
		}
		break;
	case EVENT_FlagGameReset:
		{
		}
		break;
	case EVENT_FlagReward:
		{
			int team = *(int*)&event.p[0];
			int reward = *(int*)&event.p[1];
		}
		break;
//////// Timed ////////
	case EVENT_TimedGameOver:
		{
			Player *p[5];
			for (int i = 0; i < 5; i++)
				p[i] = (Player*)event.p[i];
		}
		break;
//////// Soccer ////////
	case EVENT_SoccerGoal:
		{
			int team = *(int*)&event.p[0];
			int reward = *(int*)&event.p[1];
		}
		break;
	case EVENT_BallMove:
		{
			PBall *ball = (PBall*)event.p[0];
		}
		break;
//////// File ////////
	case EVENT_File:
		{
			char *name = (char*)event.p[0];
		}
		break;
//////// Player ////////
	case EVENT_PlayerEntering:
		{
			Player *p = (Player*)event.p[0];
		}
		break;
	case EVENT_PlayerMove:
		{
			Player *p = (Player*)event.p[0];
		}
		break;
	case EVENT_PlayerWeapon:
		{
			Player *p = (Player*)event.p[0];
			weaponInfo wi;
			wi.n = *(Uint16*)&event.p[1];
		}
		break;
	case EVENT_WatchDamage:
		{
			Player *p = (Player*)event.p[0];	// player
			Player *k = (Player*)event.p[1];	// attacker
			weaponInfo wi;
			wi.n = *(Uint16*)&event.p[2];
			Uint16 energy = *(Uint16*)&event.p[3];
			Uint16 damage = *(Uint16*)&event.p[4];
		}
		break;
	case EVENT_PlayerDeath:
		{
			Player *p = (Player*)event.p[0],
				   *k = (Player*)event.p[1];
			Uint16 bounty = (Uint16)event.p[2];

			if(Enabled && p==theRabbit)
			{
				String Message="*arena Rabbit:";
				Message+=theRabbit->name;
				Message+=" has been killed by ";
				Message+=k->name;
				Message+="! Adding new rabbit....";
				sendPublic(Message);
				SetRabbit(k);
			}
		}
		break;
	case EVENT_PlayerScore:
		{
			Player *p = (Player*)event.p[0];
		}
		break;
	case EVENT_PlayerPrize:
		{
			Player *p = (Player*)event.p[0];
			int prize = *(int *)&event.p[1];
		}
		break;
	case EVENT_PlayerShip:
		{
			Player *p = (Player*)event.p[0];
			Uint16 oldship = (Uint16)event.p[1];
			Uint16 oldteam = (Uint16)event.p[2];

			if(Enabled && p==theRabbit)
			{PrizeRabbit();}
		}
		break;
	case EVENT_PlayerSpec:
		{
			Player *p = (Player*)event.p[0];
			Uint16 oldteam = (Uint16)event.p[1];
			Uint16 oldship = (Uint16)event.p[2];

			if(Enabled)
			{
				if(getIngame()<2)
				{
					if(theRabbit!=NULL && p!=theRabbit)
					{
						String Message;
						if(theRabbit->ship!=RabbitShip)
						{
							Message="*setship ";
							Message+=RabbitShip;
							sendPrivate(theRabbit,Message);
						}
		
						if(theRabbit->team!=RabbitTeam)
						{
							Message="*setfreq ";
							Message+=RabbitTeam;
							sendPrivate(theRabbit,Message);
						}
						sendPrivate(theRabbit,"*shipreset");
					}
					theRabbit=NULL;
					Enabled=false;
					sendPublic("*timer 0");
					sendPublic("*arena Two players required inorder to play rabbit! Rabbit Stopped :(");
				}
				else
				{
					if(p==theRabbit)
					{
						Player* newRab=RandPlayer();
						if(newRab!=NULL)
						{	
							String Msg="*arena Rabbit:";
							Msg+=theRabbit->name;
							Msg+=" has spectated! New Rabbit being picked....";
							sendPublic(Msg);
							theRabbit=NULL;
							SetRabbit(newRab);
						}
					}
				}
			}
		}
		break;
	case EVENT_PlayerTeam:
		{
			Player *p = (Player*)event.p[0];
			Uint16 oldteam = (Uint16)event.p[1];
			Uint16 oldship = (Uint16)event.p[2];

			if(Enabled && p==theRabbit)
			{PrizeRabbit();}
		}
		break;
	case EVENT_PlayerLeaving:
		{
			Player *p = (Player*)event.p[0];
			//player is still on the playerlist, so the functions have to work around them
			if(Enabled&&p->ship!=8&&!p->safety)
			{
				if(getIngame()-1<2)
				{
					if(theRabbit!=NULL && p!=theRabbit)
					{
						String Message;
						if(theRabbit->ship!=RabbitShip)
						{
							Message="*setship ";
							Message+=RabbitShip;
							sendPrivate(theRabbit,Message);
						}
		
						if(theRabbit->team!=RabbitTeam)
						{
							Message="*setfreq ";
							Message+=RabbitTeam;
							sendPrivate(theRabbit,Message);
						}
						sendPrivate(theRabbit,"*shipreset");
					}	
					theRabbit=NULL;
					Enabled=false;
					sendPublic("*timer 0");
					sendPublic("*arena Two players required inorder to play rabbit! Rabbit Stopped :(");
				}
				else
				{
					if(p==theRabbit)
					{
						Player* newRab=RandPlayer();
						if(newRab!=NULL)
						{	
							String Msg="*arena Rabbit:";
							Msg+=theRabbit->name;
							Msg+=" has left the arena! New Rabbit being picked....";
							sendPublic(Msg);
							theRabbit=NULL;
							SetRabbit(newRab);
						}
					}
				}
			}
			
			killTags(p);
		}
		break;
//////// Selfish ////////
	case EVENT_SelfShipReset:
		{
		}
		break;
	case EVENT_SelfPrize:
		{
			Uint16 prize = (Uint16)event.p[0];
			Uint16 count = (Uint16)event.p[1];
		}
		break;
	case EVENT_SelfUFO:
		{
		}
		break;
	case EVENT_PositionHook:
		{
		}
		break;
//////// Bricks ////////
	case EVENT_BrickDropped:
		{
			int x1 = *(int*)&event.p[0];
			int y1 = *(int*)&event.p[1];
			int x2 = *(int*)&event.p[2];
			int y2 = *(int*)&event.p[3];
			int team = *(int*)&event.p[4];
		}
		break;
//////// LVZ ////////
	case EVENT_ObjectToggled:
		{
			objectInfo obj;
			obj.n = (Uint16)event.p[0];
		}
		break;
//////// Turret ////////
	case EVENT_CreateTurret:
		{
			Player *turreter = (Player*)event.p[0];
			Player *turretee = (Player*)event.p[1];
		}
		break;
	case EVENT_DeleteTurret:
		{
			Player *turreter = (Player*)event.p[0];
			Player *turretee = (Player*)event.p[1];
		}
		break;
//////// Chat ////////
	case EVENT_Chat:
		{
			int type  = *(int*)&event.p[0];
			int sound = *(int*)&event.p[1];
			Player *p = (Player*)event.p[2];
			char *msg = (char*)event.p[3];

			switch (type)
			{
			case MSG_Arena:
				{
					//prizing happens so fast that the 
					//player's variables such as p->bounty
					//dont get updated in time. SO this
					//solves the problem. 
					if(Enabled && GotBty && sound==SND_None && CMPSTR("Granting prize(s)",msg))
					{GotBty=false;}
				}
				break;
			case MSG_PublicMacro:		if (!p) break;
				{
				}
				break;
			case MSG_Public:			if (!p) break;
				{
				}
				break;
			case MSG_Team:				if (!p) break;
				{
				}
				break;
			case MSG_TeamPrivate:		if (!p) break;
				{
				}
				break;
			case MSG_Private:			if (!p) break;
				{
				}
				break;
			case MSG_PlayerWarning:		if (!p) break;
				{
				}
				break;
			case MSG_RemotePrivate:
				{
				}
				break;
			case MSG_ServerError:
				{
				}
				break;
			case MSG_Channel:
				{
				}
				break;
			};
		}
		break;
	case EVENT_LocalCommand:
		{
			Player *p = (Player*)event.p[0];
			Command *c = (Command*)event.p[1];

			gotCommand(p, c);
		}
		break;
	case EVENT_LocalHelp:
		{
			Player *p = (Player*)event.p[0];
			Command *c = (Command*)event.p[1];

			gotHelp(p, c);
		}
		break;
	case EVENT_RemoteCommand:
		{
			char *p = (char*)event.p[0];
			Command *c = (Command*)event.p[1];
			Operator_Level o = *(Operator_Level*)&event.p[2];

			gotRemote(p, c, o);
		}
		break;
	case EVENT_RemoteHelp:
		{
			char *p = (char*)event.p[0];
			Command *c = (Command*)event.p[1];
			Operator_Level o = *(Operator_Level*)&event.p[2];

			gotRemoteHelp(p, c, o);
		}
		break;
//////// Containment ////////
	case EVENT_Init:
		{
			int major	= HIWORD(*(int*)&event.p[0]);
			int minor	= LOWORD(*(int*)&event.p[0]);
			callback	= (CALL_COMMAND)event.p[1];
			playerlist	= (CALL_PLIST)event.p[2];
			flaglist	= (CALL_FLIST)event.p[3];
			map			= (CALL_MAP)event.p[4];
			bricklist	= (CALL_BLIST)event.p[5];

			if (major > CORE_MAJOR_VERSION)
			{
				tell(makeEcho("DLL plugin cannot connect.  This plugin is out of date."));

				CONNECTION_DENIED = true;

				return;
			}
			else if ((major < CORE_MAJOR_VERSION) || (minor < CORE_MINOR_VERSION))
			{
				tell(makeEcho("DLL plugin cannot connect.  This plugin requires the latest version of MERVBot."));

				CONNECTION_DENIED = true;

				return;
			}
			else
			{
				tell(makeEcho("DLL plugin connected."));
			
				char buffer[250]; //holds the input from the file
				char Path[512]; //file path
				GetCurrentDirectory(512, Path); //grab the path
				strcat(Path, "\\rabbit.ini"); //append the file name

				ZeroMemory(buffer, 3); 
				GetPrivateProfileString("Status", "Enabled", NULL, buffer, 2, Path);
				if(buffer[0]>='1')
				{Status=true;}

				ZeroMemory(buffer, 6); 
				GetPrivateProfileString("Rabbit", "Bounty", NULL, buffer, 5, Path);
				if(isNumeric(buffer))
				{Bounty= getInteger(buffer,10);}

				ZeroMemory(buffer, 101); 
				GetPrivateProfileString("Rabbit", "Prizes", NULL, buffer, 100, Path);
				if(buffer[0])
				{Prizes=buffer;}

				ZeroMemory(buffer, 6); 
				GetPrivateProfileString("Rabbit", "SetFreq", NULL, buffer, 5, Path);
				if(isNumeric(buffer))
				{
					SetFreq= getInteger(buffer,10);
					if(!(SetFreq>=0&&SetFreq<=9999))
					{SetFreq=UNASSIGNED;}
				}

				ZeroMemory(buffer, 6); 
				GetPrivateProfileString("Rabbit", "SetShip", NULL, buffer, 5, Path);
				if(isNumeric(buffer))
				{
					SetShip= getInteger(buffer,10);
					
					if(SetShip>=1 && SetShip<=8)
					{SetShip--;}
					else
					{SetShip=UNASSIGNED;}
				}

				ZeroMemory(buffer, 6); 
				GetPrivateProfileString("Rabbit", "TimeAlive", NULL, buffer, 5, Path);
				if(isNumeric(buffer))
				{RabbitTime= getInteger(buffer,10)*60;}

				ZeroMemory(buffer, 6); 
				GetPrivateProfileString("Rabbit", "TimeAllowedInSafe", NULL, buffer, 5, Path);
				if(isNumeric(buffer))
				{SafeTime= getInteger(buffer,10);}

				ZeroMemory(buffer, 6); 
				GetPrivateProfileString("Rabbit", "IgnoreFlaggers", NULL, buffer, 5, Path);
				if(isNumeric(buffer) && getInteger(buffer,10) > 0)
				{IgnoreFlaggers=true;}
				
				ArenaMsg *newMsg;
				TimeMsg *newTime;
				String Count;
				for(Uint16 i=1;i<=100;i++)
				{
					Count="RabbitMsg";
					Count+=i;

					ZeroMemory(buffer, 250); 
					GetPrivateProfileString(Count.msg, "Msg", NULL, buffer, 250, Path);
					if(buffer[0])
					{
						newMsg=new ArenaMsg;
						newMsg->theMsg="*arena ";
						newMsg->theMsg+=buffer;
						
						ZeroMemory(buffer, 6);
						GetPrivateProfileString(Count.msg, "Sound", NULL, buffer, 6, Path);
						if(isNumeric(buffer))
						{newMsg->Sound=getInteger(buffer,10);}
						else
						{newMsg->Sound=UNASSIGNED;}

						MsgList.append(newMsg);
					}

					Count="TimeMsg";
					Count+=i;

					ZeroMemory(buffer, 250); 
					GetPrivateProfileString(Count.msg, "Msg", NULL, buffer, 250, Path);
					if(buffer[0])
					{
						newTime=new TimeMsg;
						newTime->theMsg="*arena ";
						newTime->theMsg+=buffer;
						
						ZeroMemory(buffer, 6);
						GetPrivateProfileString(Count.msg, "Sound", NULL, buffer, 6, Path);
						if(isNumeric(buffer))
						{newTime->Sound=getInteger(buffer,10);}
						else
						{newTime->Sound=UNASSIGNED;}

						ZeroMemory(buffer, 6);
						GetPrivateProfileString(Count.msg, "Time", NULL, buffer, 6, Path);
						if(isNumeric(buffer))
						{
							newTime->Time=getInteger(buffer,10);
							TimeList.append(newTime);
						}
						else
						{delete newTime;}		
					}
						
				}
				MsgList.beginCyclic();
				ml=MsgList.head;
			}

		}
		break;
	case EVENT_Term:
		{
			tell(makeEcho("DLL plugin disconnected."));
		}
		break;
	};
}


//////// DLL export ////////

_declspec(dllexport) void __stdcall talk(BotEvent &event)
{
	botInfo *bot;

	bot = findBot(event.handle);

	if (!bot)
	{
		bot = new botInfo(event.handle);
		botlist.append(bot);
	}

	if (bot) bot->gotEvent(event);
}


//////// Tag emulation ////////

int botInfo::get_tag(Player *p, int index)
{
	_listnode <PlayerTag> *parse = taglist.head;
	PlayerTag *tag;

	while (parse)
	{
		tag = parse->item;

		if (tag->p == p)
		if (tag->index == index)
			return tag->data;

		parse = parse->next;
	}

	return 0;
}

void botInfo::set_tag(Player *p, int index, int data)
{
	_listnode <PlayerTag> *parse = taglist.head;
	PlayerTag *tag;

	while (parse)
	{
		tag = parse->item;

		if (tag->p == p)
		if (tag->index == index)
		{
			tag->data = data;
			return;
		}

		parse = parse->next;
	}

	tag = new PlayerTag;
	tag->p = p;
	tag->index = index;
	tag->data = data;
	taglist.append(tag);
}

void botInfo::killTags(Player *p)
{
	_listnode <PlayerTag> *parse = taglist.head;
	PlayerTag *tag;

	while (parse)
	{
		tag = parse->item;
		parse = parse->next;

		if (tag->p != p) continue;

		taglist.kill(tag);
	}
}

void botInfo::killTags()
{
	taglist.clear();
}


//////// LVZ Object Toggling ////////

void botInfo::clear_objects()
{
	num_objects = 0;
}

void botInfo::object_target(Player *p)
{
	object_dest = p;
}

void botInfo::toggle_objects()
{
	Player *p = object_dest;

	if (!p)	tell(makeToggleObjects(UNASSIGNED, (Uint16 *)object_array, num_objects));
	else	tell(makeToggleObjects(p->ident, (Uint16 *)object_array, num_objects));

	num_objects = 0;
}

void botInfo::queue_enable(int id)
{
	if (num_objects == MAX_OBJECTS)
		toggle_objects();

	object_array[num_objects].id = id;
	object_array[num_objects].disabled = false;
	++num_objects;
}

void botInfo::queue_disable(int id)
{
	if (num_objects == MAX_OBJECTS)
		toggle_objects();

	object_array[num_objects].id = id;
	object_array[num_objects].disabled = true;
	++num_objects;
}


//////// Chatter ////////

void botInfo::sendPrivate(Player *player, BYTE snd, char *msg)
{
	tell(makeSay(MSG_Private, snd, player->ident, msg));
}

void botInfo::sendPrivate(Player *player, char *msg)
{
	tell(makeSay(MSG_Private, 0, player->ident, msg));
}

void botInfo::sendTeam(char *msg)
{
	tell(makeSay(MSG_Team, 0, 0, msg));
}

void botInfo::sendTeam(BYTE snd, char *msg)
{
	tell(makeSay(MSG_Team, snd, 0, msg));
}

void botInfo::sendTeamPrivate(Uint16 team, char *msg)
{
	tell(makeSay(MSG_TeamPrivate, 0, team, msg));
}

void botInfo::sendTeamPrivate(Uint16 team, BYTE snd, char *msg)
{
	tell(makeSay(MSG_TeamPrivate, snd, team, msg));
}

void botInfo::sendPublic(char *msg)
{
	tell(makeSay(MSG_Public, 0, 0, msg));
}

void botInfo::sendPublic(BYTE snd, char *msg)
{
	tell(makeSay(MSG_Public, snd, 0, msg));
}

void botInfo::sendPublicMacro(char *msg)
{
	tell(makeSay(MSG_PublicMacro, 0, 0, msg));
}

void botInfo::sendPublicMacro(BYTE snd, char *msg)
{
	tell(makeSay(MSG_PublicMacro, snd, 0, msg));
}

void botInfo::sendChannel(char *msg)
{
	tell(makeSay(MSG_Channel, 0, 0, msg));
}

void botInfo::sendRemotePrivate(char *msg)
{
	tell(makeSay(MSG_RemotePrivate, 0, 0, msg));
}

void botInfo::sendRemotePrivate(char *name, char *msg)
{
	String s;
	s += ":";
	s += name;
	s += ":";
	s += msg;

	sendRemotePrivate(s);
}
